/***************************************************************************
 *   Copyright (C) 2006 by M.Fedotov   *
 *   mo_fedotov@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef AR_CLIENT_H
#define AR_CLIENT_H

#include "bt_comm.h"
#include "ar_parser.h"

#define ALARM_CLEAN 	0
#define ALARM_CHECK 	1

/**
	@author M.Fedotov <mo_fedotov@mail.ru>
*/
class AR_Client {

public:
    AR_Client();
    ~AR_Client();

    bool connectToBT	    (QString s);
    int  listenForConnection(void);
    bool isConnected	    (void);
    bool initServerPort	    (void);
    void setStyle   	    (QString device);
    void setInitialized     (void);
    bool isServer	    	(void);
    bool stillPressed	    (void);
    int  checkCallActive    (void);
    type_key* getAutoRepeatCmdIndex(void);
    int  handleCommand	    (char * c);
    int  readCommand	    (QString& buffer, int l);
    void Disconnect 	    (void);
    void handleDisconnect   (bool needClose);
    void manageAlarms	    (int m);
	BtComm getComm			(void);
	QString getCallerID		(void);
	void cleanupRepeatKeys	(void);
    bool isBemusedCommand	(char* cmd);

    int     serverMode;
    int     port;
    int     initialized;
  
private:

    int 	handleKeyPress	(char* key);
    
	//int		paramValue;
    bool    callOn;
    bool    repeatNow;
    bool    useCallId;
    BtComm  Comm;
    type_key*  repeatCmdPtr;
    QString callerId;
    QString modifierString;
};

#endif
